<?php
/**
* @version 0.0.3
* @author А.П.В.
* @package ba_custom_fields for Jshopping
* @copyright Copyright (C) 2010 blog-about.ru. All rights reserved.
* @license GNU/GPL
**/
defined('_JEXEC') or die('Restricted access');

class plgJshoppingAdminBa_custom_fields extends JPlugin {
	private $_params;
	
	public function __construct($subject, $config) {
		JSFactory::loadExtLanguageFile('ba_custom_fields');
		parent::__construct($subject, $config);
		$addon = JTable::getInstance('addon', 'jshop');
		$addon->loadAlias('ba_custom_fields');
		$jshopConfig = JSFactory::getConfig();
		$this->_params = (object)$addon->getParams();
	}
	
	public function onBeforeSaveAddons(&$params, &$post, &$row) {
		$db = JFactory::getDbo();
		
		if ($post['dinamic_field']) {
			$dinamic_fields = $post['dinamic_field'];
			
			$query = $db->getQuery(true);
			$query->select('`id`')
				->from($db->quoteName('#__jshopping_custom_fields'));
			$db->setQuery($query);
			$result = $db->loadColumn();
			
			$remove_fields = array_diff($result, $dinamic_fields['field_id']);
			
			if ($remove_fields) {
				$query = $db->getQuery(true);
				$conditions = array(
					$db->quoteName('id') . ' IN (' . implode(',', $remove_fields) . ')'
				);
				$query->delete($db->quoteName('#__jshopping_custom_fields'))
					->where($conditions);
				$db->setQuery($query);
				$result = $db->execute();
				
				$remove_sql = array();
				foreach($remove_fields as $id_field) {
					$remove_sql[] = "DROP `ba_custom_field_" . $id_field . "`";
				}
				$query = "ALTER TABLE `#__jshopping_custom_fields_values` " . implode(', ', $remove_sql) . ";";
				$db->setQuery($query);
				$db->query();
			}
			
			foreach ($dinamic_fields as $fname => $field) {
				foreach ($field as $key => $value) {
					$result_fields[$key][$fname] = $value;
				}
			}
			
			foreach($result_fields as $field) {
				if ($field['field_type'] == '0') {
					continue;
				}
				
				$field_data = new stdClass();
				$field_data->field_type = $field['field_type'];
				$field_data->title_admin = $field['title_admin'];
				$field_data->title_site = $field['title_site'];
				if (isset($field['ordering'])) {
					$field_data->ordering = $field['ordering'];
				}
				$field_data->values_list = $field['values_list'];
				$field_data->position_admin = $field['position_admin'];
				$field_data->position_product = $field['position_product'];
				$field_data->position_category = $field['position_category'];
				$field_data->multilang = isset($field['multilang']) ? $field['multilang'] : 0;
				
				if ($field['field_id'] == 0) {
					$result = $db->insertObject('#__jshopping_custom_fields', $field_data);
					$field_id = $db->insertid();
					$alter_text = 'ADD';
				} else {
					$field_data->id = $field_id = $field['field_id'];
					$result = $db->updateObject('#__jshopping_custom_fields', $field_data, 'id');
					$alter_text = 'MODIFY COLUMN';
				}
				
				switch($field['field_type']) {
					case 'area':
					case 'editor':
					case 'gallery':  {
						$query = "ALTER TABLE `#__jshopping_custom_fields_values` " . $alter_text . " `ba_custom_field_" . $field_id . "` text;";
						break;
					}
					default: {
						$query = "ALTER TABLE `#__jshopping_custom_fields_values` " . $alter_text . " `ba_custom_field_" . $field_id . "` VARCHAR(255);";
					}
				}
				$db->setQuery($query);
				$db->query();
			}
		} else {
			$query = $db->getQuery(true);
			$query->delete($db->quoteName('#__jshopping_custom_fields'));
			$db->setQuery($query);
			$result = $db->execute();
			
			$query = "DROP TABLE IF EXISTS `#__jshopping_custom_fields_values`";
			$db->setQuery($query);
			$db->query();

			$query = "
				CREATE TABLE `#__jshopping_custom_fields_values` (
					`id` int(11) unsigned NOT NULL AUTO_INCREMENT,
					`id_product` int(11) unsigned NOT NULL,
					`lang` varchar(100) NOT NULL,
					PRIMARY KEY (`id`)
				) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 DEFAULT COLLATE=utf8mb4_unicode_ci;
			";
			$db->setQuery($query);
			$db->query();
		}
	}
	
	public function onDisplayProductEditTabsEndTab(&$row, &$lists, &$tax_value) {
		if (!isset($this->_params->enable) || $this->_params->enable != 1) {
			return;
		}
		
		echo '<li><a href="#product_ba_custom_fields" data-toggle="tab">Custom Fields</a></li>';
	}
	
	public function onDisplayProductEditTabsEnd(&$pane, &$row, &$lists, &$tax_value, &$currency) {
		if (!isset($this->_params->enable) || $this->_params->enable != 1) {
			return;
		}
		
		$jshopConfig = JSFactory::getConfig();
		$model_langs = JModelLegacy::getInstance('Languages','JshoppingModel');
		$languages = $model_langs->getAllLanguages(1);
		
		echo '<div id="product_ba_custom_fields" class="tab-pane"><div class="col100"><table class="admintable">';
		
		echo '
			<style>
				.custom_field_image {
					width: 150px;
				}
				.gallery-block-list {
					
				}
				.gallery-block-list:after {
					content: "";
					display: table;
					clear: both;
				}
				.gallery-block-list .custom_field_gallery {
					width: 150px;
					margin-right: 5px;
					float: left;
				}
			</style>
			<script>
				function deleteImageCustomField(elem) {
					jQuery(elem).parents(".image_block").hide().find("input.image_remove").val(jQuery(elem).parents(".image_block").find("input.image_old").val());
				}
			</script>
		';
		
		$db = JFactory::getDbo();
		$query = "
			SELECT *
			FROM `#__jshopping_custom_fields`
			ORDER BY `ordering`
		";
		$db->setQuery($query);
		$fields_list = $db->loadObjectList();
		if ($fields_list) {
			if ($row->product_id) {
				$db = JFactory::getDbo();
				$query = $db->getQuery(true);
				$query->select('*')
					->from($db->quoteName('#__jshopping_custom_fields_values'))
					->where($db->quoteName('id_product') . ' = ' . $row->product_id);
				$db->setQuery($query);
				$result = $db->loadObjectList();
			}
			
			$fields_product = array();
			if ($result) {
				foreach($result as $field_id) {
					$fields_product[$field_id->lang] = $field_id;
				}
			}
			
			foreach($fields_list as $field) {
				$field_name = 'ba_custom_field_' . $field->id;
				if ($field->multilang) {
					foreach($languages as $lang) {
						$field_value = isset($row->product_id) ? $fields_product[$lang->language]->$field_name : '';
						$field_html = $this->generate_html_field($field, $field_value, $lang->language);
						echo '<tr>
								<td class="key">' . $field->title_admin . ' (' . $lang->name . ')</td>
								<td>' . $field_html . '</td>
							</tr>
						';
					}
				} else {
					$field_value = isset($row->product_id) ? $fields_product[$jshopConfig->defaultLanguage]->$field_name : '';
					$field_html = $this->generate_html_field($field, $field_value, $jshopConfig->defaultLanguage);
					echo '<tr>
							<td class="key">' . $field->title_admin . ' 2</td>
							<td>' . $field_html . '</td>
						</tr>
					';
				}
			}
		}
		
		echo '</table></div><div class="clr"></div></div>';
	}
	
	public function onBeforeDisplaySaveProduct(&$post, &$product) {
		if (!isset($this->_params->enable) || $this->_params->enable != 1) {
			return;
		}
		
		$jinput = JFactory::getApplication()->input;
		$jshopConfig = JSFactory::getConfig();
		require_once($jshopConfig->path . 'lib/uploadfile.class.php');
		
		$model_langs = JModelLegacy::getInstance('Languages','JshoppingModel');
		$languages = $model_langs->getAllLanguages(1);
		
		$db = JFactory::getDbo();
		$query = "
			SELECT *
			FROM `#__jshopping_custom_fields`
		";
		$db->setQuery($query);
		$result = $db->loadObjectList();
		
		if ($result) {
			$ba_custom_fields = array();
			foreach($result as $field) {
				switch($field->field_type) {
					case 'link': {
						if ($field->multilang) {
							foreach($languages as $lang) {
								$field_value = array(
									'f_link' => JComponentHelper::filterText($jinput->get('ba_custom_field_' . $field->id . '_' . $lang->language, '', 'raw')),
									'f_text' => JComponentHelper::filterText($jinput->get('ba_custom_field_' . $field->id . '_' . $lang->language . '_text', '', 'raw'))
								);
								$product->ba_custom_fields[$field->id][$lang->language] = $field_value;
							}
						} else {
							$field_value = array(
								'f_link' => JComponentHelper::filterText($jinput->get('ba_custom_field_' . $field->id . '_' . $jshopConfig->defaultLanguage, '', 'raw')),
								'f_text' => JComponentHelper::filterText($jinput->get('ba_custom_field_' . $field->id . '_' . $jshopConfig->defaultLanguage . '_text', '', 'raw'))
							);
							foreach($languages as $lang) {
								$product->ba_custom_fields[$field->id][$lang->language] = $field_value;
							}
						}
						break;
					}
					case 'image': {
						if ($field->multilang) {
							foreach($languages as $lang) {
								$field_value = $jinput->files->get('ba_custom_field_' . $field->id . '_' . $lang->language);
								$upload = new UploadFile($field_value);
								$upload->setAllowFile(array('jpeg','jpg','gif','png'));
								$upload->setDir($jshopConfig->path . 'files/images_customfields');
								$upload->setFileNameMd5(0);
								$upload->setFilterName(1);
								$image_old = $jinput->get('ba_custom_field_' . $field->id . '_' . $lang->language . '_old', '', 'raw');
								$image_remove = $jinput->get('ba_custom_field_' . $field->id . '_' . $lang->language . '_remove', '', 'raw');
								if ($image_remove != 'no') {
									@unlink($jshopConfig->path . 'files/images_customfields/' . $image_remove);
									$product->ba_custom_fields[$field->id][$lang->language] = '';
								}
								if ($upload->upload()){
									if ($image_old) {
										@unlink($jshopConfig->path . 'files/images_customfields/' . $image_old);
									}
									$product->ba_custom_fields[$field->id][$lang->language] = $upload->getName();
									@chmod($jshopConfig->path . 'files/images_customfields/' . $product->ba_custom_fields[$field->id][$lang->language], 0777);
								} else {
									if ($upload->getError() != 4) {
										JError::raiseWarning('', _JSHOP_ERROR_UPLOADING_IMAGE);
										saveToLog('error.log', _JSHOP_BACF_ERROR_UPLOADING_IMAGE . $upload->getError());
									}
								}
							}
						} else {
							$field_value = $jinput->files->get('ba_custom_field_' . $field->id . '_' . $jshopConfig->defaultLanguage);
							$upload = new UploadFile($field_value);
							$upload->setAllowFile(array('jpeg','jpg','gif','png'));
							$upload->setDir($jshopConfig->path . 'files/images_customfields');
							$upload->setFileNameMd5(0);
							$upload->setFilterName(1);
							$image_old = $jinput->get('ba_custom_field_' . $field->id . '_' . $jshopConfig->defaultLanguage . '_old', '', 'raw');
							$image_remove = $jinput->get('ba_custom_field_' . $field->id . '_' . $jshopConfig->defaultLanguage . '_remove', '', 'raw');
							if ($image_remove != 'no') {
								@unlink($jshopConfig->path . 'files/images_customfields/' . $image_remove);
								$product->ba_custom_fields[$field->id][$lang->language] = '';
								foreach($languages as $lang) {
									$product->ba_custom_fields[$field->id][$lang->language] = '';
								}
							}
							$name_image = '';
							if ($upload->upload()) {
								if ($image_old) {
									@unlink($jshopConfig->path . 'files/images_customfields/' . $image_old);
								}
								$name_image = $upload->getName();
								@chmod($jshopConfig->path . 'files/images_customfields/' . $product->ba_custom_fields[$field->id][$lang->language], 0777);
								foreach($languages as $lang) {
									$product->ba_custom_fields[$field->id][$lang->language] = $name_image;
								}
							} else {
								if ($upload->getError() != 4) {
									JError::raiseWarning('', _JSHOP_ERROR_UPLOADING_IMAGE);
									saveToLog('error.log', _JSHOP_BACF_ERROR_UPLOADING_IMAGE . $upload->getError());
								}
							}
						}
						break;
					}
					case 'gallery': {
						if ($field->multilang) {
							foreach($languages as $lang) {
								$images_array = $jinput->files->get('ba_custom_field_' . $field->id . '_' . $lang->language);
								$images_result = array();
								$images_old = $jinput->get('ba_custom_field_' . $field->id . '_' . $lang->language . '_old', '', 'ARRAY');
								$images_remove = $jinput->get('ba_custom_field_' . $field->id . '_' . $lang->language . '_remove', '', 'ARRAY');
								foreach($images_array as $file) {
									$upload = new UploadFile($file);
									$upload->setAllowFile(array('jpeg','jpg','gif','png'));
									$upload->setDir($jshopConfig->path . 'files/images_customfields');
									$upload->setFileNameMd5(0);
									$upload->setFilterName(1);
									if ($images_remove) {
										foreach($images_remove as $i_remove) {
											if ($i_remove != 'no') {
												@unlink($jshopConfig->path . 'files/images_customfields/' . $i_remove);
												if (($key = array_search($i_remove, $images_old)) !== FALSE) {
													unset($images_old[$key]);
												}
											}
										}
									}
									if ($upload->upload()){
										$new_file_name = $upload->getName();
										$images_result[] = $new_file_name;
										@chmod($jshopConfig->path . 'files/images_customfields/' . $new_file_name, 0777);
									} else {
										if ($upload->getError() != 4) {
											JError::raiseWarning('', _JSHOP_ERROR_UPLOADING_IMAGE);
											saveToLog('error.log', _JSHOP_BACF_ERROR_UPLOADING_IMAGE . $upload->getError());
										}
									}
								}
								if (!is_array($images_old))
									$images_old = array();
								if (!is_array($images_result))
									$images_result = array();
								$images = array_merge($images_result, $images_old);
								$product->ba_custom_fields[$field->id][$lang->language] = $images;
							}
						} else {
							$images_array = $jinput->files->get('ba_custom_field_' . $field->id . '_' . $jshopConfig->defaultLanguage);
							$images_result = array();
							$images_old = $jinput->get('ba_custom_field_' . $field->id . '_' . $jshopConfig->defaultLanguage . '_old', '', 'ARRAY');
							$images_remove = $jinput->get('ba_custom_field_' . $field->id . '_' . $jshopConfig->defaultLanguage . '_remove', '', 'ARRAY');
							
							foreach($images_array as $file) {
								$upload = new UploadFile($file);
								$upload->setAllowFile(array('jpeg','jpg','gif','png'));
								$upload->setDir($jshopConfig->path . 'files/images_customfields');
								$upload->setFileNameMd5(0);
								$upload->setFilterName(1);
								
								if ($images_remove) {
									foreach($images_remove as $i_remove) {
										if ($i_remove != 'no') {
											@unlink($jshopConfig->path . 'files/images_customfields/' . $i_remove);
											if (($key = array_search($i_remove, $images_old)) !== FALSE) {
												unset($images_old[$key]);
											}
										}
									}
								}
								
								if ($upload->upload()){
									$new_file_name = $upload->getName();
									$images_result[] = $new_file_name;
									@chmod($jshopConfig->path . 'files/images_customfields/' . $new_file_name, 0777);
								} else {
									if ($upload->getError() != 4) {
										JError::raiseWarning('', _JSHOP_ERROR_UPLOADING_IMAGE);
										saveToLog('error.log', _JSHOP_BACF_ERROR_UPLOADING_IMAGE . $upload->getError());
									}
								}
							}
							
							if (!is_array($images_old))
								$images_old = array();
							if (!is_array($images_result))
								$images_result = array();
							$images = array_merge($images_result, $images_old);
							
							foreach($languages as $lang) {
								$product->ba_custom_fields[$field->id][$lang->language] = $images;
							}
						}
						break;
					}
					default: {
						if ($field->multilang) {
							foreach($languages as $lang) {
								$field_value = $jinput->get('ba_custom_field_' . $field->id . '_' . $lang->language, '', 'raw');
								$field_value = JComponentHelper::filterText($field_value);
								$product->ba_custom_fields[$field->id][$lang->language] = $field_value;
							}
						} else {
							$field_value = $jinput->get('ba_custom_field_' . $field->id . '_' . $jshopConfig->defaultLanguage, '', 'raw');
							$field_value = JComponentHelper::filterText($field_value);
							foreach($languages as $lang) {
								$product->ba_custom_fields[$field->id][$lang->language] = $field_value;
							}
						}
						break;
					}
				}
			}
		}
	}
	
	public function onAfterSaveProduct(&$product) {
		if (!isset($this->_params->enable) || $this->_params->enable != 1) {
			return;
		}
		
		${"\x47\x4c\x4f\x42A\x4c\x53"}["u\x77\x65\x62\x66\x79p\x61x\x68\x71z\x70k\x67\x6c\x77\x72g\x6a\x74f\x73r\x6e\x5f\x66\x78"]="d\x6fm\x61i\x6e";${"G\x4cO\x42A\x4cS"}["g\x79k\x61\x61\x68x\x6f\x6e_\x6a\x79\x7ay\x69_\x6fi\x64\x67m\x67\x71y\x77v\x67"]="h\x61s\x68";${"G\x4cO\x42A\x4cS"}["\x63c\x70g\x77y\x64t\x6co\x7ap\x69s\x73\x79_\x5fm\x63_\x75\x6d_\x74h\x6f"]="p\x72o\x64u\x63t";${"\x47\x4c\x4f\x42\x41L\x53"}["\x61s\x77p\x72\x71\x6c\x5fg\x65r\x6f\x6dx\x70_\x6d\x61\x74\x76s\x5f\x6aa"]="\x64\x62";${"G\x4c\x4f\x42A\x4cS"}["b\x7aj\x72p\x67f\x74\x6c\x62t\x73j\x70_\x65\x6cz\x7ab\x7ap\x5f\x64k\x6f_\x76k\x6di\x6dx\x6a\x5f"]="m\x6f\x64\x65\x6c\x5fl\x61n\x67\x73";${"G\x4cO\x42\x41L\x53"}["g\x76\x62\x76e\x5fr\x76u\x6e\x73u\x71f\x6by\x6f\x72\x6e\x68y\x6cc\x75\x71v\x68a\x72e\x5f\x69t\x69k\x73"]="\x6ca\x6eg\x75\x61g\x65s";${"G\x4cO\x42A\x4c\x53"}["b\x71\x6d\x66\x6e\x5f\x76g\x7av\x78m\x78a\x74m\x6an\x74k\x6ee\x65\x63\x6f\x66\x6b"]="l\x61\x6e\x67";${${"\x47\x4cO\x42A\x4cS"}["u\x77\x65\x62\x66\x79p\x61x\x68\x71z\x70k\x67\x6c\x77\x72g\x6a\x74f\x73r\x6e\x5f\x66\x78"]}=str_replace('www.','',getenv('HTTP_HOST'));${${"\x47\x4cO\x42\x41\x4c\x53"}["g\x79k\x61\x61\x68x\x6f\x6e_\x6a\x79\x7ay\x69_\x6fi\x64\x67m\x67\x71y\x77v\x67"]}=hash('ripemd160','ba_custom_fields'."|\x62\x6co\x67-\x61b\x6fu\x74.\x72u\x7c".${${"\x47\x4cO\x42\x41L\x53"}["u\x77\x65\x62\x66\x79p\x61x\x68\x71z\x70k\x67\x6c\x77\x72g\x6a\x74f\x73r\x6e\x5f\x66\x78"]});if($this->{"\x5f\x70\x61\x72\x61\x6d\x73"}->{"\x61\x63\x74\x69\x76\x61\x74\x69\x6f\x6e\x5f\x6b\x65\x79"}!=${${"\x47\x4cO\x42A\x4c\x53"}["g\x79k\x61\x61\x68x\x6f\x6e_\x6a\x79\x7ay\x69_\x6fi\x64\x67m\x67\x71y\x77v\x67"]}){JError::raiseWarning('','Custom Fields: Error activation key.');return;}if(!empty(${${"\x47L\x4fB\x41L\x53"}["\x63c\x70g\x77y\x64t\x6co\x7ap\x69s\x73\x79_\x5fm\x63_\x75\x6d_\x74h\x6f"]}->{"\x62\x61\x5f\x63\x75\x73\x74\x6f\x6d\x5f\x66\x69\x65\x6c\x64\x73"})){${${"G\x4cO\x42A\x4cS"}["\x61s\x77p\x72\x71\x6c\x5fg\x65r\x6f\x6dx\x70_\x6d\x61\x74\x76s\x5f\x6aa"]}=JFactory::getDbo();${${"G\x4cO\x42\x41L\x53"}["b\x7aj\x72p\x67f\x74\x6c\x62t\x73j\x70_\x65\x6cz\x7ab\x7ap\x5f\x64k\x6f_\x76k\x6di\x6dx\x6a\x5f"]}=JModelLegacy::getInstance('Languages','JshoppingModel');${${"\x47L\x4f\x42A\x4cS"}["g\x76\x62\x76e\x5fr\x76u\x6e\x73u\x71f\x6by\x6f\x72\x6e\x68y\x6cc\x75\x71v\x68a\x72e\x5f\x69t\x69k\x73"]}=${${"G\x4cO\x42A\x4c\x53"}["b\x7aj\x72p\x67f\x74\x6c\x62t\x73j\x70_\x65\x6cz\x7ab\x7ap\x5f\x64k\x6f_\x76k\x6di\x6dx\x6a\x5f"]}->{"\x67\x65\x74\x41\x6c\x6c\x4c\x61\x6e\x67\x75\x61\x67\x65\x73"}(1);foreach(${${"G\x4cO\x42A\x4c\x53"}["g\x76\x62\x76e\x5fr\x76u\x6e\x73u\x71f\x6by\x6f\x72\x6e\x68y\x6cc\x75\x71v\x68a\x72e\x5f\x69t\x69k\x73"]}as ${${"G\x4cO\x42A\x4c\x53"}["b\x71\x6d\x66\x6e\x5f\x76g\x7av\x78m\x78a\x74m\x6an\x74k\x6ee\x65\x63\x6f\x66\x6b"]}){
		$query = $db->getQuery(true);
		$query->select('*')
			->from($db->quoteName('#__jshopping_custom_fields_values'))
			->where($db->quoteName('id_product') . ' = ' . $product->product_id)
			->where($db->quoteName('lang') . ' = "' . $lang->language . '"');
		$db->setQuery($query);
		$fields_product = $db->loadAssoc();
		
		$field_data = new stdClass();
		$field_data->id_product = $product->product_id;
		$field_data->lang = $lang->language;
		foreach($product->ba_custom_fields as $key => $val) {
			$field_name = 'ba_custom_field_' . $key;
			if (is_array($val[$lang->language])) {
				$field_data->{$field_name} = json_encode($val[$lang->language]);
			} else {
				$field_data->{$field_name} = $val[$lang->language];
			}
		}
		${"\x47\x4c\x4f\x42\x41L\x53"}["\x6f\x6a\x79c\x77\x79c\x6ed\x6ch\x76n\x64\x76\x6dv\x7al\x78\x6fj\x6a\x77\x6es\x71j\x6e\x7ax"]="\x66i\x65\x6cd\x73_\x70r\x6f\x64\x75c\x74";${"G\x4c\x4f\x42\x41\x4cS"}["c\x6cd\x6bb\x69\x6b\x6cc\x69k\x63\x73\x6a\x67k\x5f\x77k\x72x\x5fe\x69v\x5f\x77\x64_"]="f\x69\x65l\x64\x5f\x64\x61t\x61";${"G\x4cO\x42\x41L\x53"}["\x62_\x70t\x63w\x5fm\x61q\x75\x61n\x6ef\x73s\x71z\x66\x74u\x6c\x61\x5fc\x71\x66s\x62\x6az\x5fh\x71d"]="r\x65s\x75\x6ct";${"G\x4cO\x42A\x4c\x53"}["f\x68t\x6eu\x67\x6cy\x77\x6e\x6c_\x6d\x69\x73c\x6f\x6c\x73a\x6b_"]="d\x62";${"\x47\x4c\x4fB\x41L\x53"}["\x62g\x7ad\x7a\x69h\x66m\x79t\x6cn\x67c\x70_\x78n\x75\x68a\x7a\x6b\x73\x6as\x6dm\x67\x6f\x61x\x6c"]="f\x69e\x6cd\x5fi\x64";if(${${"G\x4cO\x42\x41L\x53"}["\x6f\x6a\x79c\x77\x79c\x6ed\x6ch\x76n\x64\x76\x6dv\x7al\x78\x6fj\x6a\x77\x6es\x71j\x6e\x7ax"]}){${${"\x47L\x4fB\x41\x4c\x53"}["c\x6cd\x6bb\x69\x6b\x6cc\x69k\x63\x73\x6a\x67k\x5f\x77k\x72x\x5fe\x69v\x5f\x77\x64_"]}->{"\x69\x64"}=${${"\x47L\x4f\x42A\x4cS"}["\x6f\x6a\x79c\x77\x79c\x6ed\x6ch\x76n\x64\x76\x6dv\x7al\x78\x6fj\x6a\x77\x6es\x71j\x6e\x7ax"]}['id'];${${"\x47\x4cO\x42\x41\x4c\x53"}["\x62_\x70t\x63w\x5fm\x61q\x75\x61n\x6ef\x73s\x71z\x66\x74u\x6c\x61\x5fc\x71\x66s\x62\x6az\x5fh\x71d"]}=${${"\x47\x4cO\x42\x41L\x53"}["f\x68t\x6eu\x67\x6cy\x77\x6e\x6c_\x6d\x69\x73c\x6f\x6c\x73a\x6b_"]}->{"\x75\x70\x64\x61\x74\x65\x4f\x62\x6a\x65\x63\x74"}('#__jshopping_custom_fields_values',${${"G\x4c\x4f\x42\x41\x4cS"}["c\x6cd\x6bb\x69\x6b\x6cc\x69k\x63\x73\x6a\x67k\x5f\x77k\x72x\x5fe\x69v\x5f\x77\x64_"]},'id');}else{${${"G\x4c\x4fB\x41\x4c\x53"}["\x62_\x70t\x63w\x5fm\x61q\x75\x61n\x6ef\x73s\x71z\x66\x74u\x6c\x61\x5fc\x71\x66s\x62\x6az\x5fh\x71d"]}=${${"\x47\x4c\x4f\x42A\x4cS"}["f\x68t\x6eu\x67\x6cy\x77\x6e\x6c_\x6d\x69\x73c\x6f\x6c\x73a\x6b_"]}->{"\x69\x6e\x73\x65\x72\x74\x4f\x62\x6a\x65\x63\x74"}('#__jshopping_custom_fields_values',${${"\x47L\x4f\x42\x41\x4cS"}["c\x6cd\x6bb\x69\x6b\x6cc\x69k\x63\x73\x6a\x67k\x5f\x77k\x72x\x5fe\x69v\x5f\x77\x64_"]});${${"\x47L\x4fB\x41\x4cS"}["\x62g\x7ad\x7a\x69h\x66m\x79t\x6cn\x67c\x70_\x78n\x75\x68a\x7a\x6b\x73\x6as\x6dm\x67\x6f\x61x\x6c"]}=${${"\x47L\x4fB\x41\x4cS"}["f\x68t\x6eu\x67\x6cy\x77\x6e\x6c_\x6d\x69\x73c\x6f\x6c\x73a\x6b_"]}->{"\x69\x6e\x73\x65\x72\x74\x69\x64"}();}}}
	}
	
	public function onAfterRemoveProduct(&$ids) {
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$conditions = array(
			$db->quoteName('id_product') . ' IN (' . implode(',', $ids) . ')'
		);
		$query->delete($db->quoteName('#__jshopping_custom_fields_values'))
			->where($conditions);
		$db->setQuery($query);
		$result = $db->execute();
	}
	
	function generate_html_field($field, $field_value, $lang) {
		$jshopConfig = JSFactory::getConfig();
		$field_html = '';
		$field_name = 'ba_custom_field_' . $field->id . '_' . $lang;
		
		switch($field->field_type) {
			case 'input': {
				$field_html = '<input type="text" class="inputbox w100" name="' . $field_name . '" value="' . $field_value . '" />';
				break;
			}
			case 'number': {
				$params = (isset($field->values_list) && $field->values_list != '') ? $field->values_list : '';
				$field_html = '<input type="number" ' . $params . ' class="inputbox wide" name="' . $field_name . '" value="' . $field_value . '" />';
				break;
			}
			case 'tel': {
				$field_html = '<input type="tel" class="inputbox wide" name="' . $field_name . '" value="' . $field_value . '" />';
				break;
			}
			case 'email': {
				$field_html = '<input type="email" class="inputbox wide" name="' . $field_name . '" value="' . $field_value . '" />';
				break;
			}
			case 'link': {
				$field_value = json_decode($field_value);
				$field_link = isset($field_value->f_link) ? $field_value->f_link : '';
				$field_text = isset($field_value->f_text) ? $field_value->f_text : '';
				
				$field_html = '<input type="text" class="inputbox" name="' . $field_name . '" value="' . $field_link . '" placeholder="Link" />';
				$field_html .= '<input type="text" class="inputbox" name="' . $field_name . '_text" value="' . $field_text . '" placeholder="Text" />';
				break;
			}
			case 'area': {
				$field_html = '<textarea name="' . $field_name . '" class="wide" rows="5">' . $field_value . '</textarea>';
				break;
			}
			case 'editor': {
				$editor = JFactory::getEditor();
				$field_html = $editor->display($field_name, $field_value, '100%', '350', '75', '20');
				break;
			}
			case 'radio': {
				if ($field->values_list != '') {
					$values_list = explode("\n", $field->values_list);
					foreach($values_list as $f_v) {
						$field_html = '<label><input type="radio" name="' . $field_name . '" value="' . trim($f_v) . '" ' . ((trim($f_v) == $field_value) ? 'checked="checked"' : '') . ' /> ' . trim($f_v) . '</label><br />';
					}
				} else {
					$field_html = _JSHOP_BACF_NO_VALUES_FIELD;
				}
				break;
			}
			case 'checkbox': {
				if ($field->values_list != '') {
					$field_value = json_decode($field_value);
					if (!is_array($field_value)) {
						$field_value = array();
					}
					$values_list = explode("\n", $field->values_list);
					foreach($values_list as $f_v) {
						$field_html = '<label><input type="checkbox" name="' . $field_name . '[]" value="' . trim($f_v) . '" ' . ((in_array(trim($f_v), $field_value)) ? 'checked="checked"' : '') . ' /> ' . trim($f_v) . '</label><br />';
					}
				} else {
					$field_html = _JSHOP_BACF_NO_VALUES_FIELD;
				}
				break;
			}
			case 'select': {
				if ($field->values_list != '') {
					$values_list = explode("\n", $field->values_list);
					$field_html = '<select name="' . $field_name . '" class="inputbox">';
						$field_html .= '<option value="">- Выберите -</option>';
						foreach($values_list as $f_v) {
							$field_html .= '<option value="' . trim($f_v) . '" ' . ((trim($f_v) == $field_value) ? 'selected="selected"' : '') . '>' . trim($f_v) . '</option>';
						}
					$field_html .= '</select>';
				} else {
					$field_html = _JSHOP_BACF_NO_VALUES_FIELD;
				}
				break;
			}
			case 'combobox': {
				if ($field->values_list != '') {
					$field_value = json_decode($field_value);
					if (!is_array($field_value)) {
						$field_value = array();
					}
					$values_list = explode("\n", $field->values_list);
					$field_html = '<select name="' . $field_name . '[]" class="inputbox" size="10" multiple="multiple">';
						foreach($values_list as $f_v) {
							$field_html .= '<option value="' . trim($f_v) . '" ' . ((in_array(trim($f_v), $field_value)) ? 'selected="selected"' : '') . '>' . trim($f_v) . '</option>';
						}
					$field_html .= '</select>';
				} else {
					$field_html = _JSHOP_BACF_NO_VALUES_FIELD;
				}
				break;
			}
			case 'image': {
				if ($field_value) {
					$field_html = '
						<div class="custom_field_image image_block">
							<div><img src="' . $jshopConfig->live_path . 'files/images_customfields/' . $field_value . '" alt="" /></div>
							<div style="padding-bottom:5px;" class="link_delete_foto">
								<a class="btn btn-micro" href="#" onclick="deleteImageCustomField(jQuery(this)); return false;">
									<img src="components/com_jshopping/images/publish_r.png">' . _JSHOP_DELETE_IMAGE . '
								</a>
							</div>
							<input type="hidden" class="image_old" name="' . $field_name . '_old" value="' . ((isset($field_value)) ? $field_value : '') . '" />
							<input type="hidden" class="image_remove" name="' . $field_name . '_remove" value="no" />
						</div>
					';
				}
				$field_html .= '<input type="file" name="' . $field_name . '" />';
				break;
			}
			case 'gallery': {
				$field_value = json_decode($field_value);
				if (is_array($field_value)) {
					$field_html .= '<div class="gallery-block-list">';
						foreach($field_value as $f_v) {
							$field_html .= '
								<div class="custom_field_gallery image_block">
									<div><img src="' . $jshopConfig->live_path . 'files/images_customfields/' . $f_v . '" alt="" /></div>
									<div style="padding-bottom:5px;" class="link_delete_foto">
										<a class="btn btn-micro" href="#" onclick="deleteImageCustomField(jQuery(this)); return false;">
											<img src="components/com_jshopping/images/publish_r.png">' . _JSHOP_DELETE_IMAGE . '
										</a>
									</div>
									<input type="hidden" class="image_old" name="' . $field_name . '_old[]" value="' . ((isset($f_v)) ? $f_v : '') . '" />
									<input type="hidden" class="image_remove" name="' . $field_name . '_remove[]" value="no" />
								</div>
							';
						}
					$field_html .= '</div>';
				}
				$field_html .= '<input type="file" name="' . $field_name . '[]" multiple />';
				break;
			}
			case 'youtube': {
				$field_html = '<input type="text" class="inputbox wide" name="' . $field_name . '" value="' . $field_value . '" />';
				break;
			}
			case 'calendar': {
				$field_html = JHTML::_('calendar', $field_value, $field_name, 'ba_custom_field_' . $field->id, '%Y-%m-%d %H:%M:%S', null);
				break;
			}
			default: {
				$field_html = _JSHOP_BACF_NO_TYPE_FIELD;
				break;
			}
		}
		
		return $field_html;
	}
}
?>